{% extends 'base.html' %}
{% block title %}Facelook | Post{% endblock %}
{% block content %}
<!-- POSTS SECTION START -->

<div style="display:flex;flex-direction:column;max-width: 600px;width:100%;align-items: center;margin:0 auto">
<h1><a href="{% url 'topic'  post.topic.id %}" style="color: var(--primary-color)">{{ post.topic.title }}</a></h1>

<section id="posts-container" style="width:100%">
    <div id="{{ post.id }}">
        <div class="box" style="margin-bottom: 1rem;">
            <p>{{ post.text }}</p>
            <div style="display:flex;align-items: center;gap:10px;color:#666;font-size:13px;font-weight: 500;">
                <div style="display:flex;align-items:center;gap:3px">
                    {% load static %}
                    <img src="{% static 'user_images/pngegg.png' %}" style="width:15px;height:15px;border-radius:50%">
                    <a href="{% url 'posts_for_user' post.creator.id %}"><span style="text-overflow: ellipsis">
                            @{{post.creator.username }}</span></a>
                </div>
                <div style="display:flex;align-items:center;gap:3px; ">
                    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
                        <path
                            d="M232 120C232 106.7 242.7 96 256 96C269.3 96 280 106.7 280 120V243.2L365.3 300C376.3 307.4 379.3 322.3 371.1 333.3C364.6 344.3 349.7 347.3 338.7 339.1L242.7 275.1C236 271.5 232 264 232 255.1L232 120zM256 0C397.4 0 512 114.6 512 256C512 397.4 397.4 512 256 512C114.6 512 0 397.4 0 256C0 114.6 114.6 0 256 0zM48 256C48 370.9 141.1 464 256 464C370.9 464 464 370.9 464 256C464 141.1 370.9 48 256 48C141.1 48 48 141.1 48 256z" />
                    </svg>
                    <span>Il y a {{ post.date|timesince }}</span>
                    {% if post.creator == request.user %}
                    <a href="{% url 'edit_post' post.id %}" style="padding-left: 30px;">
                        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512">
                            <path
                                d="M373.1 24.97C401.2-3.147 446.8-3.147 474.9 24.97L487 37.09C515.1 65.21 515.1 110.8 487 138.9L289.8 336.2C281.1 344.8 270.4 351.1 258.6 354.5L158.6 383.1C150.2 385.5 141.2 383.1 135 376.1C128.9 370.8 126.5 361.8 128.9 353.4L157.5 253.4C160.9 241.6 167.2 230.9 175.8 222.2L373.1 24.97zM440.1 58.91C431.6 49.54 416.4 49.54 407 58.91L377.9 88L424 134.1L453.1 104.1C462.5 95.6 462.5 80.4 453.1 71.03L440.1 58.91zM203.7 266.6L186.9 325.1L245.4 308.3C249.4 307.2 252.9 305.1 255.8 302.2L390.1 168L344 121.9L209.8 256.2C206.9 259.1 204.8 262.6 203.7 266.6zM200 64C213.3 64 224 74.75 224 88C224 101.3 213.3 112 200 112H88C65.91 112 48 129.9 48 152V424C48 446.1 65.91 464 88 464H360C382.1 464 400 446.1 400 424V312C400 298.7 410.7 288 424 288C437.3 288 448 298.7 448 312V424C448 472.6 408.6 512 360 512H88C39.4 512 0 472.6 0 424V152C0 103.4 39.4 64 88 64H200z" />
                        </svg>
                        Modifier</a>

                    <a href="{% url 'delete' post.id 'post'  %}" style="padding-left: 10px;" data-cy="delete-post">
                        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Pro 6.2.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M135.2 17.7L128 32H32C14.3 32 0 46.3 0 64S14.3 96 32 96H416c17.7 0 32-14.3 32-32s-14.3-32-32-32H320l-7.2-14.3C307.4 6.8 296.3 0 284.2 0H163.8c-12.1 0-23.2 6.8-28.6 17.7zM416 128H32L53.2 467c1.6 25.3 22.6 45 47.9 45H346.9c25.3 0 46.3-19.7 47.9-45L416 128z"/></svg>
                        Supprimer</a>
                    {% endif %}
                </div>
            </div>
            <div>
                <button data-id="{{ post.id }}" onclick="likePost(this)" data-cy="like-post" id="btn-post-lik"
                {% if post.liked %} class="post-liked" {% endif %}> <span id="likes-counter">
                        {{ post.like_counter }}</span> <span> likes</span>
                </button>
                <button data-id="{{ post.id }}" onclick="dislikePost(this)" data-cy="deslike-post" id="btn-post-dislik"
                {% if post.disliked %} class="post-disliked" {% endif %}>
                    <span id="dislikes-counter">{{ post.dislike_counter }}</span><span> dislikes</span>
                </button>
            </div>
        </div>
    </div>
</section>
</div>

<style>
    .post-liked {
        color: blue;
    }

    .post-disliked {
        color: blue;
    }
</style>
<script>
    async function likePost(el) {
        const id = el.getAttribute('data-id');
        let like = document.getElementById(id).querySelector('#btn-post-lik');
        let dislike = document.getElementById(id).querySelector('#btn-post-dislik');
        let likesCounter = document.getElementById(id).querySelector('#likes-counter');
        let deslikesCounter = document.getElementById(id).querySelector('#dislikes-counter');

        await fetch('/api/post/' + id + '/like');

        if (!like.classList.contains('post-liked')) {
            like.classList.add('post-liked');
            if (dislike.classList.contains('post-disliked')) {
                dislike.classList.remove('post-disliked')
            }
        } else {
            like.classList.remove('post-liked');
        }
        updateNbs(id);

    }


    async function dislikePost(el) {
        const id = el.getAttribute('data-id');
        let like = document.getElementById(id).querySelector('#btn-post-lik');
        let dislike = document.getElementById(id).querySelector('#btn-post-dislik');
        let likesCounter = document.getElementById(id).querySelector('#likes-counter');
        let deslikesCounter = document.getElementById(id).querySelector('#dislikes-counter');

        await fetch('/api/post/' + id + '/dislike');
        if (!dislike.classList.contains('post-disliked')) {
            dislike.classList.add('post-disliked');
            if (like.classList.contains('post-liked')) {
                like.classList.remove('post-liked')
            }
        } else {
            dislike.classList.remove('post-disliked');
        }
        updateNbs(id)

    }

    function updateNbs(id) {
        let likesCounter = document.getElementById(id).querySelector('#likes-counter');
        let deslikesCounter = document.getElementById(id).querySelector('#dislikes-counter');
        fetch('/api/post/' + id + '/nombers/likes')
            .then(response => response.json())
            .then(data => {
                likesCounter.innerHTML = data['likes']
                deslikesCounter.innerHTML = data['dislikes']
            });
    }
</script>
<!-- POSTS SECTION END -->
{% endblock %}